var RnaQcAliquot = function()
{
	var rnaqc = {};
	
	var HISENSE_LIMIT = 35.0;
	
	var selectedRna;
	var selectedBioPlate;
	var subtypeRna = null;
	var bioPlateNameIsValid = false;
	
	var autoGoNext = 0;
	var newRna = [];
	
	// Page initialization
	rnaqc.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', rnaqc.validateStep1);
		Buttons.addClickHandler('btnSelectRna', rnaqc.selectRna);
		Events.addEventHandler('rna', 'base-selected', rnaqc.onRnaSelected);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', rnaqc.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', rnaqc.validateStep2);
		Events.addEventHandler('bioPlates', 'change', rnaqc.bioPlateOnChange);
		Events.addEventHandler('CALIPER_RNAQC', 'click', rnaqc.bioPlateTypeOnChange);
		Events.addEventHandler('BA_RNAQC', 'click', rnaqc.bioPlateTypeOnChange);
		Events.addEventHandler('bioPlateName', 'change', rnaqc.bioPlateNameOnChange);

		// Step 3
		Events.addEventHandler('step-3', 'wizard-initialize', rnaqc.initializeStep3);
		Events.addEventHandler('step-3', 'wizard-validate', rnaqc.validateStep3);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);

		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', rnaqc.submit);

		var rna = Data.json('page-data', 'rna-id');
		if (rna.length > 0)
		{
			Doc.show('step-1');
			autoGoNext = rna.length;
			// Get more information about the selected rna
			var url = '../RnaQc.servlet?ID='+App.getSessionId();
			url += '&cmd=GetRnaInfo&rnaIds=' + rna.join(',');
			Wizard.asyncJsonRequest(url, rnaqc.onRnaInfoLoaded);
		}
		else
		{
			var url = '../RnaQc.servlet?ID='+App.getSessionId();
			url += '&cmd=GetRnaExtractsWithoutQc';
			Wizard.showLoadingAnimation('Loading RNA extracts...');
			Wizard.asyncJsonRequest(url, rnaqc.onRnaLoaded);
		}
	}
	
	rnaqc.onRnaLoaded = function(response)
	{
		var frm = document.forms['reggie'];
		var rnaExtracts = response.rnaExtracts;
		
		if (rnaExtracts.length > 0)
		{
			for (var i=0; i < rnaExtracts.length; i++)
			{
				var selected = i < 12;
				var rna = rnaExtracts[i];
				rnaqc.addRnaOption(frm.rna, rna, selected);
			}
		}
		else
		{	
			Wizard.setInputStatus('rna', 'invalid', 'No RNA available for quality control.');
		}
		
		Doc.show('step-1');
		Doc.show('gonext');
	}
	
	rnaqc.selectRna = function()
	{
		var frm = document.forms['reggie'];
		if (frm.rna.disabled) return;
		
		if (subtypeRna == null)
		{
			subtypeRna = Reggie.getSubtypeInfo('RNA');
		}
		
		newRna = [];
		var url = '&resetTemporary=1';
		url += '&tmpfilter:INT:itemSubtype='+subtypeRna.id;
		Dialogs.selectItem('EXTRACT', 'rna', 1, url);
	}

	rnaqc.onRnaSelected = function(event)
	{
		var rna = event.detail;
		
		var frm = document.forms['reggie'];
		var rnaList = frm.rna;
		var isNew = true;
		for (var i = 0; i < rnaList.length; i++)
		{
			if (rnaList[i].value == rna.id)
			{
				rnaList[i].selected = true;
				isNew = false;
			}
		}
		
		if (isNew) newRna[newRna.length] = rna.id;
		
		if (event.detail.remaining == 0 && newRna.length > 0)
		{
			// Get more information about the selected rna
			var url = '../RnaQc.servlet?ID='+App.getSessionId();
			url += '&cmd=GetRnaInfo&rnaIds=' + newRna.join(',');
			Wizard.asyncJsonRequest(url, rnaqc.onRnaInfoLoaded);
		}
	}

	rnaqc.onRnaInfoLoaded = function(response)
	{
		var frm = document.forms['reggie'];
		var rnaList = response.rna;

		for (var rnaNo = 0; rnaNo < rnaList.length; rnaNo++)
		{
			var rna = rnaList[rnaNo];
			rnaqc.addRnaOption(frm.rna, rna, true);
		}
		
		if (frm.rna.length == autoGoNext)
		{
			Wizard.goNext(true);
		}
	}
	
	rnaqc.addRnaOption = function(list, rna, selected)
	{
		var name = rna.name;
		if (rna.bioWell)
		{
			name += ' -- ' + rna.bioWell.bioPlate.name + ' (' + Reggie.wellToAlpha(rna.bioWell.row)+(rna.bioWell.column+1)+')';
		}

		var option = new Option(name, rna.id, selected, selected);
		option.rna = rna;
		list[list.length] = option;
	}
	
	rnaqc.validateStep1 = function(event)
	{
		var frm = document.forms['reggie'];
		var rnaList = frm.rna;
		
		selectedRna = [];
		for (var i=0; i < rnaList.length; i++)
		{
			if (rnaList[i].selected)
			{
				selectedRna[selectedRna.length] = rnaList[i].rna;
			}
		}
			
		if (selectedRna.length == 0)
		{
			Wizard.setInputStatus('rna', 'invalid', 'Not selected', 'invalid');
			event.preventDefault();
		}
		else
		{
			Wizard.setInputStatus('rna', 'valid');
		}
	}

	rnaqc.initializeStep2 = function()
	{
		var frm = document.forms['reggie'];
		Wizard.setCurrentStep(2);
		Doc.show('gonext');
		
		Reggie.loadProtocols('QUALITY_CONTROL', 'protocols');

		var url = '../RnaQc.servlet?ID='+App.getSessionId();
		url += '&cmd=GetActiveRnaQcBioPlates&numFreeWells=' + selectedRna.length;
		Doc.addClass('bioPlates', 'list-loading');
		frm.bioPlates[0] = new Option('loading...');
		Wizard.asyncJsonRequest(url, rnaqc.bioPlatesLoaded);
	}
	
	rnaqc.bioPlatesLoaded = function(response)
	{
		var frm = document.forms['reggie'];
		frm.bioPlates.length = 0;
		Doc.removeClass('bioPlates', 'list-loading');

		var plates = response.plates;
		for (var i = 0; i < plates.length; i++)
		{
			frm.bioPlates[frm.bioPlates.length] = new Option(plates[i].name + ' -- ' + plates[i].freeWells + ' free wells', plates[i].id);
		}
		frm.bioPlates[frm.bioPlates.length] = new Option('- create new -', 0);
	
		rnaqc.bioPlateOnChange();
		frm.bioPlates.focus();
	}
	
	// If the 'create new' option is selected we need to display that section
	rnaqc.bioPlateOnChange = function()
	{
		var frm = document.forms['reggie'];
		
		var createNewSelected = parseInt(frm.bioPlates.value) == 0;
		Doc.showHide('createNewBioPlateSection', createNewSelected);
		
		if (createNewSelected)
		{
			if (frm.bioPlateName.value == '') 
			{
				rnaqc.bioPlateTypeOnChange();
			}
			frm.bioPlateBarcode.focus();
		}
	}

	//	We need to get the next auto-generated name for a new CaliperPlate or BAPlate
	rnaqc.bioPlateTypeOnChange = function()
	{
		var frm = document.forms['reggie'];
		var selectedType = Forms.getCheckedRadio(frm.bioPlateType);
		if (selectedType.nextPlateName)
		{
			rnaqc.onNextPlateNameGenerated();
		}
		else
		{
			var url = '../RnaQc.servlet?ID='+App.getSessionId();
			url += '&cmd=GetNextAutoGeneratedPlateName&bioPlateType=' + selectedType.value;
			Wizard.asyncJsonRequest(url, rnaqc.onNextPlateNameGenerated);
		}
	}

	rnaqc.onNextPlateNameGenerated = function(response)
	{
		var frm = document.forms['reggie'];
		var selectedType = Forms.getCheckedRadio(frm.bioPlateType);
		if (response)
		{
			selectedType.nextPlateName = response.nextPlateName;
		}
		
		frm.bioPlateName.value = selectedType.nextPlateName;
		rnaqc.bioPlateNameOnChange();
	}

	rnaqc.bioPlateNameOnChange = function()
	{
		var frm = document.forms['reggie'];
		
		var bioPlateName = frm.bioPlateName.value;
		bioPlateNameIsValid = false;
		if (bioPlateName == '')
		{
			Wizard.setInputStatus('bioPlateName', 'invalid', 'Missing');
			return;
		}
		
		bioPlateNameIsValid = true;
		if (bioPlateName.indexOf('CaliperPlate') != 0 && bioPlateName.indexOf('BAPlate') != 0)
		{
			Wizard.setInputStatus('bioPlateName', 'warning', 'Should start with <i>CaliperPlate</code> or <i>BAPlate</i>.');
			return;
		}

		Wizard.setInputStatus('bioPlateName', 'valid');
	}
	
	rnaqc.validateStep2 = function(event)
	{
		var frm = document.forms['reggie'];
		var bioPlateId = parseInt(frm.bioPlates.value);
		if (bioPlateId == 0 && !bioPlateNameIsValid)
		{
			event.preventDefault();
		}
	}

	rnaqc.initializeStep3 = function()
	{
		var frm = document.forms['reggie'];
		var bioPlateId = parseInt(frm.bioPlates.value);
		
		var url = '../RnaQc.servlet?ID='+App.getSessionId();
		url += '&cmd=GetFreeWellsInfo&bioPlateId='+bioPlateId;
		if (bioPlateId == 0)
		{
			url += '&bioPlateType=' + Forms.getCheckedRadio(frm.bioPlateType).value;
		}
		Wizard.showLoadingAnimation('Loading information about free wells...');
		Wizard.asyncJsonRequest(url, rnaqc.freeWellsLoaded);
	}
	
	rnaqc.freeWellsLoaded = function(response)
	{
		var frm = document.forms['reggie'];

		selectedBioPlate = response.bioPlate;
		if (selectedBioPlate.id == 0)
		{
			selectedBioPlate.name = frm.bioPlateName.value;
			selectedBioPlate.barcode = frm.bioPlateBarcode.value;
		}
		
		var html = '<table id="rnaQcTable" class="step-form">';
		// First header row
		html += '<tr>';
		html += '<th>RNA QC</th>';
		html += '<th colspan="2" class="dottedleft">' + Strings.encodeTags(selectedBioPlate.name) + '</th>';
		html += '<th class="dottedleft">HiSense</th>';
		html += '<th>NDConc</th>';
		html += '<th></th>';
		html += '<th></th>';
		html += '</tr>';
		// Second header row
		html += '<tr>';
		html += '<th></th>';
		html += '<td class="dottedleft">Row</td>';
		html += '<td>Column</td>';
		html += '<td class="dottedleft">NDConc ‹ ' + HISENSE_LIMIT + '</td>';
		html += '<td>(ng/µl)</td>';
		html += '<th></th>';
		html += '<th></th>';
		html += '</tr>';
		
		for (var i=0; i < selectedRna.length; i++)
		{
			var rna = selectedRna[i];
			rna.isValid = false;
			
			var hiSenseChecked = '';
			var ndConc = null;
			if (rna.NDConc)
			{
				ndConc = rna.NDConc;
				if (ndConc < HISENSE_LIMIT)
				{
					hiSenseChecked = 'checked';
				}
			}

			html += '<tr class="highlight">';
			html += '<td class="prompt">'+Strings.encodeTags(rna.nextRnaQcName)+'</td>';
			html += '<td class="dottedleft">';
			html += '<input name="row.'+i+'" id="row.'+i+'" type="text" style="width: 3em; text-transform:uppercase;" maxlength="2"></td>';
			html += '<td><input name="column.'+i+'" id="column.'+i+'" type="text" style="width: 3em;" maxlength="3"></td>';
			html += '<td class="dottedleft"><input name="hiSense.'+i+'" id="hiSense.'+i+'" type="checkbox" value="1" ' + hiSenseChecked + '></td>';
			html += '<td class="ndconc">'
			if (ndConc) html += Reggie.formatNumber(ndConc);
			html += '</td>';
			html += '<td class="status" id="well.'+i+'.status"></td>';
			html += '<td class="help"><span id="well.'+i+'.message" class="message"></span></td>';
			html += '</tr>'
		}
		
		Doc.element('rnaQc').innerHTML = html;
		Wizard.setCurrentStep(3);
		Doc.show('goregister');
		if (selectedRna.length > 12) Doc.addClass('step-3', 'auto-hide');
		Wizard.keepSessionAlive();

		for (var i=0; i < selectedRna.length; i++)
		{
			Events.addEventHandler('row.'+i, 'keypress', Wizard.focusOnEnter, { 'next-focus': 'column.'+i });
			Events.addEventHandler('column.'+i, 'keypress', Wizard.focusOnEnter, { 'next-focus': 'row.'+(i+1) });

			Events.addEventHandler('row.'+i, 'focus', rnaqc.wellOnFocus);
			Events.addEventHandler('row.'+i, 'change', rnaqc.wellOnChange, { 'index': i });
			Events.addEventHandler('column.'+i, 'change', rnaqc.wellOnChange, { 'index': i });
			
			rnaqc.suggestWell(i);
		}
		
		frm['row.'+0].focus();
	}

	rnaqc.wellOnFocus = function(event)
	{
		var frm = document.forms['reggie'];
		
		var index = Data.int(event.currentTarget, 'index');
		var row = frm['row.'+index].value;
		var column = frm['column.'+index].value;
		
		if (row == '' && column == '') 
		{
			rnaqc.suggestWell(index);
		}
	}
	
	rnaqc.suggestWell = function(index)
	{
		var frm = document.forms['reggie'];
		if (frm['row.'+index].disabled) return;
		
		var bioWells = selectedBioPlate.bioWells;
		
		// First, map out the wells already used in the form
		var used = [];
		for (var i = 0; i < selectedRna.length; i++)
		{
			var rna = selectedRna[i];
			if (rna.isValid)
			{
				var row = frm['row.'+i].value.toUpperCase();
				var column = frm['column.'+i].value;
				var key = row+column;
				used[key] = true;
			}
		}
		
		// Find first unused well not followed by any used well
		var lastUnused = -1;
		for (var i = 0; i < bioWells.length; i++)
		{
			var well = bioWells[i];
			var row = Reggie.wellToAlpha(well.row);
			var column = well.column+1;
			var isUsed = used[row+column];
			
			if (well.canAdd && !isUsed && lastUnused == -1)
			{
				lastUnused = i;
			}
			else if (!well.canAdd || isUsed)
			{
				lastUnused = -1;
			}
		}
		
		if (lastUnused >= 0)
		{
			var well = bioWells[lastUnused];
			frm['row.'+index].value = Reggie.wellToAlpha(well.row);
			frm['column.'+index].value = well.column+1;
			
			Wizard.setInputStatus('well.'+index, 'valid');
			selectedRna[index].isValid = true;
		}
	}
	
	rnaqc.wellOnChange = function(event)
	{
		var frm = document.forms['reggie'];

		var index = Data.int(event.currentTarget, 'index');
		var row = frm['row.'+index].value;
		var column = frm['column.'+index].value;
		
		selectedRna[index].isValid = false;
		
		if (row == '' || column == '')
		{
			Wizard.setInputStatus('well.'+index, 'invalid', 'Missing row or column');
			return;
		}
		
		var rowC = Reggie.alphaToWell(row);
		if (rowC < 0 || rowC >= selectedBioPlate.geometry.rows)
		{
			setInputStatus('well.'+index, 'invalid', 'Row must be between A-' + Reggie.wellToAlpha(selectedBioPlate.geometry.rows-1));
			return;
		}
		
		var colC = parseInt(column, 10)-1;
		if (isNaN(colC) || colC < 0 || colC >= selectedBioPlate.geometry.columns)
		{
			Wizard.setInputStatus('well.'+index, 'invalid', 'Column must be between 1-' + selectedBioPlate.geometry.columns);
			return;
		}
		
		// Find the selected well
		var well = rnaqc.getWellByCoordinate(selectedBioPlate, rowC, colC);
		
		// Check that it is not already used
		if (!well.canAdd)
		{
			Wizard.setInputStatus('well.'+index, 'invalid', 'The selected well is already used');
			return;
		}
		
		// Seems to be ok
		Wizard.setInputStatus('well.'+index, 'valid');
		selectedRna[index].isValid = true;
		
		// The final check is a duplication check
		rnaqc.duplicateWellCheck();
	}


	//	Get a well from a plate given a coordinate.
	rnaqc.getWellByCoordinate = function(bioPlate, row, col)
	{
		for (var i = 0; i < bioPlate.bioWells.length; i++)
		{
			var w = bioPlate.bioWells[i];
			if (w.row == row && w.column == col)
			{
				return w;
			}
		}
		return null;
	}

	rnaqc.duplicateWellCheck = function()
	{
		var frm = document.forms['reggie'];
		var used = [];
		var index = [];
		
		for (var i = 0; i < selectedRna.length; i++)
		{
			var rna = selectedRna[i];

			if (rna.isValid)
			{
				var row = frm['row.'+i].value.toUpperCase();
				var column = frm['column.'+i].value;

				var key = row+column;
				var dupRna = used[key];
				if (dupRna)
				{
					Wizard.setInputStatus('well.'+i, 'invalid', dupRna.nextRnaQcName + ' is using the same well');
					Wizard.setInputStatus('well.'+index[key], 'invalid', rna.nextRnaQcName + ' is using the same well');
					rna.isDuplicate = true;
					dupRna.isDuplicate = true;
				}
				else
				{
					rna.isDuplicate = false;
					Wizard.setInputStatus('well.'+i, 'valid');
				}
				used[key] = rna;
				index[key] = i;
			}
		}
	}
	
	rnaqc.validateStep3 = function(event)
	{
		var frm = document.forms['reggie'];

		// Check that no wells have an error or is duplicated
		for (var i = 0; i < selectedRna.length; i++)
		{
			var rna = selectedRna[i];
			if (!rna.isValid || rna.isDuplicate)
			{
				frm['row.'+i].focus();
				event.preventDefault();
				return;
			}
		}
	}

	rnaqc.submit = function()
	{
		var frm = document.forms['reggie'];
		
		var submitInfo = {};
		selectedBioPlate.bioWells = null;
		submitInfo.bioplate = selectedBioPlate;
		
		submitInfo.protocol = parseInt(frm.protocols.value, 10);
		
		var rnaQcExtracts = [];
		for (var i=0; i < selectedRna.length; i++)
		{
			var rnaQc = {};
			rnaQc.parentId = selectedRna[i].id;
			rnaQc.name = selectedRna[i].nextRnaQcName;
			rnaQc.row = frm['row.'+i].value;
			rnaQc.column = frm['column.'+i].value;
			rnaQc.QCHiSense = frm['hiSense.'+i].checked ? true : false;
			rnaQcExtracts[rnaQcExtracts.length] = rnaQc;
		}
		submitInfo.rnaQcExtracts = rnaQcExtracts;

		var url = '../RnaQc.servlet?ID='+App.getSessionId();
		url += '&cmd=PlaceRnaQcAliquots';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, rnaqc.submissionResults, 'POST', JSON.stringify(submitInfo));
	}

	rnaqc.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}

	return rnaqc;
}();

Doc.onLoad(RnaQcAliquot.initPage);

