<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~mrna_protocol.js" 
	styles="path.css,~../css/reggie-2.css"
/>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Lab protocols for mRNA and cDNA preparation" 
		/></p:path>

	<div class="content">

	<form name="reggie" action="mrna_protocol2.jsp" method="post" target="_blank" id="wizard" class="wizard">
	<input type="hidden" name="ID" value="<%=ID%>">
	<input type="hidden" name="view" value="list">
	<input type="hidden" name="poolSchema" value="5by24">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select mRNA bioplate</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">mRNA bioplate</td>
				<td class="input">
					<select name="bioplate" id="bioplate"></select>
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help" rowspan="2">
					<span id="bioplate.message" class="message"></span>
					Select an existing mRNA bioplate. The list contain all mRNA bioplates that
					has not yet been processed (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tbody class="info-section">
			<tr>
				<td class="prompt">Comments</td>
				<td class="info" id="comments"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			</tbody>
			<tr>
				<td class="prompt">Stratagene conc.</td>
				<td class="input">
					<input type="text" name="stratageneConc" id="stratageneConc"
						style="width: 10em;" maxlength="8"> (ng/µl)
				</td>
				<td class="status" id="stratagene.status"></td>
				<td class="help">
					<span id="stratagene.message" class="message"></span>
					If the current Stratagene concentration is given, the wizard will calculate volumes
					to use automatically.
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Lab protocols</td>
				<td class="input">
					<span id="listview" class="link" data-protocol-type="list"><img src="../images/listview.png">&nbsp;List layout</span><br>
					<span id="plateview" class="link" data-protocol-type="plate"><img src="../images/plateview.png">&nbsp;Plate layout</span><br>
				</td>
				<td class="status" id="protocol.status"></td>
				<td class="help">
					<span id="protocol.message" class="message"></span>
					The 'list layout' generates a table with one row for each well on the work plate.
					The 'plate layout' generates a grid with wells arranged according to row and column coordinates.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>